Index: /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 230)
+++ /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.cpp	(revision 231)
@@ -5904,5 +6403,9 @@
 #if QC_SIMPLE_NBDV_B0047
 #if FIX_LGE_IVMP_PARALLEL_MERGE_B0136
-      getDisMvpCand2(uiPartIdx, uiPartAddr, &cDisInfo, false); 
+      getDisMvpCand2(uiPartIdx, uiPartAddr, &cDisInfo, false
+#if MERL_VSP_C0152
+            , true
+#endif
+              ); 
 #else
       getDisMvpCand2(uiPartIdx, uiPartAddr, &cDisInfo); 
@@ -6407,4 +6910,11 @@
   }
  
+#if MERL_VSP_C0152
+  if(pcTmpCU != NULL && pcTmpCU->getVSPIndex(uiIdx))
+  {
+    return false;
+  }
+#endif
+
   if ( pcTmpCU != NULL && m_pcSlice->isEqualRef(eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx), iRefIdx) )
   {
@@ -6515,4 +7025,5 @@
   TComDataCU* pcTmpCU = NULL;
   UInt uiIdx;
+
   switch( eDir )
   {
@@ -6572,5 +7083,11 @@
     return false;
   }
-  
+
+#if MERL_VSP_C0152
+  if(pcTmpCU->getVSPIndex(uiIdx))
+  {
+    return false;
+  }
+#endif
   RefPicList eRefPicList2nd = REF_PIC_LIST_0;
   if(       eRefPicList == REF_PIC_LIST_0 )
@@ -6702,5 +7219,11 @@
   TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
   iColViewIdx = pColCU->getSlice()->getViewId();
-
+#if MERL_VSP_C0152
+  //TComDataCU *pColCU = pColPic->getCU( uiCUAddr );
+  if( pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr) < 0)
+  {
+    return false;
+  }
+#endif
 
   if (pColCU->getPic()==0||pColCU->getPartitionSize(uiPartUnitIdx)==SIZE_NONE||pColCU->isIntra(uiAbsPartAddr))
@@ -7026,5 +7549,5 @@
     return false;
   }
-  
+
   if( m_pcSlice->getRefPic( eRefPicList, iRefIdx )->getViewId() != m_pcSlice->getViewId() )
   {
@@ -7071,4 +7594,9 @@
     }
   }
+
+#if MERL_VSP_C0152 // Preventive
+  if (pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiPartIdxCenter) < 0) // NOT_VALID
+    return false;
+#endif
   
   // Scale the vector.
@@ -7846,4 +8374,8 @@
   memcpy( m_puhInterDir + uiAbsPartIdxDst, pcCU->getInterDir() + uiAbsPartIdxSrc,       sizeof( m_puhInterDir[0] ) * uiNumPartition );
 
+#if MERL_VSP_C0152 && MTK_UNCONSTRAINED_MVI_B0083
+  memcpy( m_piVSPIndex + uiAbsPartIdxDst,  pcCU->getVSPIndex() + uiAbsPartIdxSrc, sizeof( m_piVSPIndex[0] ) * uiNumPartition );
+#endif
+
 #if !MTK_UNCONSTRAINED_MVI_B0083
   memcpy( m_apiMVPIdx[0] + uiAbsPartIdxDst, pcCU->getMVPIdx(REF_PIC_LIST_0) + uiAbsPartIdxSrc, sizeof(*m_apiMVPIdx[0]) * uiNumPartition );
@@ -7953,5 +8485,5 @@
 #if QC_SIMPLE_NBDV_B0047
 #if FIX_LGE_IVMP_PARALLEL_MERGE_B0136
-  getDisMvpCand2( 0, 0,  &cDisInfo, false);
+  getDisMvpCand2( 0, 0,  &cDisInfo, false );
 #else
   getDisMvpCand2( 0, 0,  &cDisInfo);
Index: /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.h	(revision 230)
+++ /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComDataCU.h	(revision 231)
@@ -197,4 +197,8 @@
 #endif
   UChar*        m_puhMergeIndex;      ///< array of merge candidate indices
+#if MERL_VSP_C0152
+  Char*         m_piVSPIndex;         ///< array of VSP flags to indicate the current block uses synthetic predictor or not
+                                      ///< value 0: non-VSP, value 1: VSP
+#endif
 #if AMP_MRG
   Bool          m_bIsMergeAMP;
@@ -279,5 +283,9 @@
   Bool          xAddMVPCand           ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
   Bool          xAddMVPCandOrder      ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
-
+#if MERL_VSP_C0152
+  inline Bool   xAddVspMergeCand      ( UChar ucVspMergePos, Int vspIdx, Bool* bVspMvZeroDone, UInt uiDepth, Bool* abCandIsInter, Int& iCount,
+                                        UChar* puhInterDirNeighbours, TComMvField* pcMvFieldNeighbours, Int* iVSPIndexTrue, Int mrgCandIdx, DisInfo* pDisInfo );
+  inline Void   xInheritVspMode       ( TComDataCU* pcCURef, UInt uiIdx, Bool* bVspMvZeroDone, Int iCount, Int* iVSPIndexTrue, TComMvField* pcMvFieldNeighbours, DisInfo* pDInfo ) ;
+#endif
   Void          deriveRightBottomIdx        ( PartSize eCUMode, UInt uiPartIdx, UInt& ruiPartIdxRB );
   Bool          xGetColMVP( RefPicList eRefPicList, Int uiCUAddr, Int uiPartUnitIdx, TComMv& rcMv, Int& riRefIdx );
@@ -366,6 +374,6 @@
   Void          copyTextureMotionDataFrom( TComDataCU* pcCU, UInt uiDepth, UInt uiAbsPartIdxSrc, UInt uiAbsPartIdxDst = 0 );
 #endif
-  
-  // -------------------------------------------------------------------------------------------------------------------
+
+   // -------------------------------------------------------------------------------------------------------------------
   // member functions for CU data
   // -------------------------------------------------------------------------------------------------------------------
@@ -471,4 +479,12 @@
   Void          setMergeIndex         ( UInt uiIdx, UInt uiMergeIndex ) { m_puhMergeIndex[uiIdx] = uiMergeIndex;  }
   Void          setMergeIndexSubParts ( UInt uiMergeIndex, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
+
+#if MERL_VSP_C0152
+  Char*         getVSPIndex        ()                        { return m_piVSPIndex;        }
+  Char          getVSPIndex        ( UInt uiIdx )            { return m_piVSPIndex[uiIdx]; }
+  Void          setVSPIndex        ( UInt uiIdx, Int n )     { m_piVSPIndex[uiIdx] = n;    }
+  Void          setVSPIndexSubParts( Char bVSPIndex, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
+#endif
+
   template <typename T>
   Void          setSubPart            ( T bParameter, T* pbBaseLCU, UInt uiCUAddr, UInt uiCUDepth, UInt uiPUIdx );
@@ -555,5 +571,8 @@
   Void          getDisMvpCand2( UInt uiPartIdx, UInt uiPartAddr, DisInfo* pDInfo
 #if LGE_IVMP_PARALLEL_MERGE_B0136
-    , Bool bParMerg = false
+                              , Bool bParMerg = false
+#endif
+#if MERL_VSP_C0152
+                              , Bool bDepthRefine = false
 #endif
     );
@@ -567,4 +586,9 @@
 #endif
 
+#endif
+
+#if MERL_VSP_C0152
+  Pel           getMcpFromDM(TComPicYuv* pcBaseViewDepthPicYuv, TComMv* mv, Int iBlkX, Int iBlkY, Int iWidth, Int iHeight, Int* aiShiftLUT, Int iShiftPrec);
+  Void          estimateDVFromDM(UInt uiPartIdx, TComPic* picDepth, UInt uiPartAddr, TComMv* cMvPred);
 #endif
   Bool          getIViewOrgDepthMvPred( UInt uiPartIdx, RefPicList eRefPicList, Int iRefIdx, TComMv& rcMv );
@@ -685,10 +709,14 @@
   Bool          hasEqualMotion              ( UInt uiAbsPartIdx, TComDataCU* pcCandCU, UInt uiCandAbsPartIdx );
 #if SIMP_MRG_PRUN
-  Void          getInterMergeCandidates       ( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx = -1 );
-#else
-  Void          getInterMergeCandidates       ( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand );
-#endif
-  Void          deriveLeftRightTopIdxGeneral  ( PartSize eCUMode, UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLT, UInt& ruiPartIdxRT );
-  Void          deriveLeftBottomIdxGeneral    ( PartSize eCUMode, UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLB );
+#if MERL_VSP_C0152
+  Void          getInterMergeCandidates     ( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int* uiVSPIndexTrue, Int mrgCandIdx = -1 );
+#else
+  Void          getInterMergeCandidates     ( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx = -1 );
+#endif
+#else
+  Void          getInterMergeCandidates     ( UInt uiAbsPartIdx, UInt uiPUIdx, UInt uiDepth, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand );
+#endif
+  Void          deriveLeftRightTopIdxGeneral( PartSize eCUMode, UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLT, UInt& ruiPartIdxRT );
+  Void          deriveLeftBottomIdxGeneral  ( PartSize eCUMode, UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLB );
   
   
Index: /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComLoopFilter.cpp
===================================================================
--- /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 230)
+++ /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComLoopFilter.cpp	(revision 231)
@@ -439,5 +439,9 @@
   
   //-- Set BS for Intra MB : BS = 4 or 3
-  if ( pcCUP->isIntra(uiPartP) || pcCUQ->isIntra(uiPartQ) )
+  if ( pcCUP->isIntra(uiPartP) || pcCUQ->isIntra(uiPartQ) 
+#if MERL_VSP_C0152
+    || pcCUP->getVSPIndex(uiPartP) || pcCUQ->getVSPIndex(uiPartQ)
+#endif
+     )
   {
     uiBs = 2;
@@ -445,5 +449,9 @@
   
   //-- Set BS for not Intra MB : BS = 2 or 1 or 0
-  if ( !pcCUP->isIntra(uiPartP) && !pcCUQ->isIntra(uiPartQ) )
+  if ( !pcCUP->isIntra(uiPartP) && !pcCUQ->isIntra(uiPartQ) 
+#if MERL_VSP_C0152
+    && !pcCUP->getVSPIndex(uiPartP) && !pcCUQ->getVSPIndex(uiPartQ)
+#endif
+  )
   {
 #if NSQT_LFFIX
@@ -542,4 +550,11 @@
   }   // enf of "if( not Intra )"
   
+#if MERL_VSP_C0152
+  if ( pcCUP->getVSPIndex(uiPartP) || pcCUQ->getVSPIndex(uiPartQ))
+  {
+    uiBs = 0;
+  }
+#endif
+
   m_aapucBS[iDir][uiAbsPartIdx] = uiBs;
 }
Index: /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComMotionInfo.cpp
===================================================================
--- /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 230)
+++ /branches/HTM-5.1-dev3-MERL/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 231)
@@ -378,5 +378,6 @@
 
 #if MTK_UNCONSTRAINED_MVI_B0083
-Void TComCUMvField::setUndefinedMv( Int iPartAddr, Int iNumPart, Char* pePredMode, UChar* puhInterDir, Int refIdx, Int InterDir )
+Void TComCUMvField::setUndefinedMv( Int iPartAddr, Int iNumPart, Char* pePredMode, UChar* puhInterDir, Int refIdx, Int InterDir 
+                                   )
 {
   PredMode predMode = MODE_INTRA;
@@ -386,5 +387,5 @@
   { 
     predMode = static_cast<PredMode>( pePredMode[ iPartAddr+i ] );
-    if( predMode==MODE_INTRA  )
+    if( predMode == MODE_INTRA )
     {
       m_pcMv[iPartAddr+i] = cMv;
